# Copyright (c) 2012-2022, Mark Peek <mark@peek.org>
# All rights reserved.
#
# See LICENSE file for full license.
#
# *** Do not modify - this file is autogenerated ***


from . import AWSObject, AWSProperty, PropsDictType, Tags
from .validators import boolean, integer


class AutoStartConfiguration(AWSProperty):
    """
    `AutoStartConfiguration <http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-emrserverless-application-autostartconfiguration.html>`__
    """

    props: PropsDictType = {
        "Enabled": (boolean, False),
    }


class AutoStopConfiguration(AWSProperty):
    """
    `AutoStopConfiguration <http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-emrserverless-application-autostopconfiguration.html>`__
    """

    props: PropsDictType = {
        "Enabled": (boolean, False),
        "IdleTimeoutMinutes": (integer, False),
    }


class WorkerConfiguration(AWSProperty):
    """
    `WorkerConfiguration <http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-emrserverless-application-workerconfiguration.html>`__
    """

    props: PropsDictType = {
        "Cpu": (str, True),
        "Disk": (str, False),
        "Memory": (str, True),
    }


class InitialCapacityConfig(AWSProperty):
    """
    `InitialCapacityConfig <http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-emrserverless-application-initialcapacityconfig.html>`__
    """

    props: PropsDictType = {
        "WorkerConfiguration": (WorkerConfiguration, True),
        "WorkerCount": (integer, True),
    }


class InitialCapacityConfigKeyValuePair(AWSProperty):
    """
    `InitialCapacityConfigKeyValuePair <http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-emrserverless-application-initialcapacityconfigkeyvaluepair.html>`__
    """

    props: PropsDictType = {
        "Key": (str, True),
        "Value": (InitialCapacityConfig, True),
    }


class MaximumAllowedResources(AWSProperty):
    """
    `MaximumAllowedResources <http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-emrserverless-application-maximumallowedresources.html>`__
    """

    props: PropsDictType = {
        "Cpu": (str, True),
        "Disk": (str, False),
        "Memory": (str, True),
    }


class NetworkConfiguration(AWSProperty):
    """
    `NetworkConfiguration <http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-emrserverless-application-networkconfiguration.html>`__
    """

    props: PropsDictType = {
        "SecurityGroupIds": ([str], False),
        "SubnetIds": ([str], False),
    }


class Application(AWSObject):
    """
    `Application <http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-emrserverless-application.html>`__
    """

    resource_type = "AWS::EMRServerless::Application"

    props: PropsDictType = {
        "AutoStartConfiguration": (AutoStartConfiguration, False),
        "AutoStopConfiguration": (AutoStopConfiguration, False),
        "InitialCapacity": ([InitialCapacityConfigKeyValuePair], False),
        "MaximumCapacity": (MaximumAllowedResources, False),
        "Name": (str, False),
        "NetworkConfiguration": (NetworkConfiguration, False),
        "ReleaseLabel": (str, True),
        "Tags": (Tags, False),
        "Type": (str, True),
    }
